unsigned int memory = 0; 
#define MAXSIZECH 1000
#define MAXTIME 1000

void sendWebPageChunkedBegin() {
		Serial.println("Chunk Start");
    server.sendHeader(F("Cache-Control"),F("no-cache, no-store, must-revalidate"));
    server.sendHeader(F("Pragma"), F("no-cache"));
    server.sendHeader(F("Expires"), "-1");
    server.setContentLength(CONTENT_LENGTH_UNKNOWN); // *** BEGIN ***
    server.send(200, F("text/html"), "");
		Serial.println("Chunk End");

}


void sendWebPageChunkedData(PGM_P str) {
	Serial.println("Chunk Data_P_Start");
	String data=String(FPSTR(str));
	sendWebPageChunkedData(data);
	Serial.println("Chunk Data_P_End");

}

void sendWebPageChunkedData(const String &data)
{
	Serial.println("Chunk Data_Start");
  String tmp;
  delay(20);
  if (data.length() > 0) {
     //do chunked transfer encoding ourselfs (WebServer doesnt support it)
	unsigned int i = 0;

	unsigned int timeout = MAXTIME;
	Serial.println(ESP.getFreeHeap());

	// if (memory > 12000) {memory = 12000;} 
	// split into chunks of MAXSIZECH
	for (unsigned int l = 0; l < (data.length() / MAXSIZECH);l++) {
		tmp = data.substring(i, i+ MAXSIZECH);			// prepare tmp string for passing to sendContent()
 		Serial.print(".");
		timeout = MAXTIME; 								// init timeout
  	memory = ESP.getFreeHeap();					// available memory before send
 	  memory = memory - 1000;
		server.sendContent(tmp);
 		i = i + MAXSIZECH;
		while ((ESP.getFreeHeap() <= memory)&&(timeout >0)) {	// wait for memory to return or the timeout
			delay(10);	
			timeout--;		
			Serial.print("W");		
		}
		Serial.println("");
		if (timeout<=0) {
			build_wwwStatus2("Timeout Webpage = " + l);
			Serial.println("Timeout Webpage IN");
			Serial.println("Chunk Data - Timeout");

			return;
		}
	}
		
	// send remainder	
	tmp = data.substring(i, data.length());
	timeout = MAXTIME;
	memory = ESP.getFreeHeap();					// available memory before send
 	memory = memory - 1000;
	Serial.print(".");
	server.sendContent(tmp);
	while ((ESP.getFreeHeap() <= memory) && (timeout > 0)) {	// wait for memory to return
		delay(10);
		timeout--;
		Serial.print("w");		
	}
	Serial.println("");
	if (timeout<=0) {
			build_wwwStatus2("Timeout Webpage LAST");
			Serial.println("Timeout Webpage LAST");
			Serial.println("Chunk Data LAST - Timeout");
			return;
	}

    // data = F("");   //free RAM
    tmp = F("");
  }
	Serial.println("Chunk Data_End");

}


void sendWebPageChunkedEnd()
{
   server.sendContent("");
   server.client().flush();
   server.client().stop();
}

void monitorWiFi()
{
  if (WiFi.status() != WL_CONNECTED)
  {
    if (connectioWasAlive == true)
    {
      connectioWasAlive = false;
      Serial.print("Looking for WiFi ");
    }
    Serial.print(".");
    delay(500);
  }
  else if (connectioWasAlive == false)
  {
    connectioWasAlive = true;
    Serial.printf(" connected to %s\n", WiFi.SSID().c_str());
  }
}