long lastMsg = 0;
char msg[50];
int value = 0;

void subscribe(const String value) {
    String path=String(path_MQTT)+"/"+value;
    char cpath[path.length()+1];
    path.toCharArray(cpath,path.length()+1);
    pubClient.subscribe(cpath);
}



void reconnect() {
  if (MQTT_active==1) {
    startCountBlink(0.8,4);
    int timeout = 2;
    build_wwwStatus2("MQTT try reconnect");
    while ((!pubClient.connected()) && (timeout>0)) {
        timeout--;
        Serial.println("Reconnecting MQTT...");
        char devname[80];
        iDevname.toCharArray(devname,80);
        if (!pubClient.connect(devname)) {
            Serial.print("failed, rc=");
            Serial.print(pubClient.state());
            Serial.println(" retrying in 5 seconds");
            delay(500);
        }
    }
    if (pubClient.connected()) {
        subscribe("setRelay");
        sendInfoStatus("name",iDevname);
        sendInfoStatus("starttime",gerDate(NTP.getTimeDateString()));
        sendInfoStatus("stoptime","-");
        reportMQTT((relStatus=="ON")?1:0);
        Serial.println("MQTT Connected...");
        build_wwwStatus2("MQTT subscribed");
        sendInfos();
    } else {
        Serial.println("MQTT NOT Connected...");
        build_wwwStatus2("MQTT NOT subscribed");
    }
  }
}

void callbackMQTT(char* topic, byte* payload, unsigned int length) {
  if (MQTT_active==1) {  
    Serial.print("Received message [");
    Serial.print(topic);
    Serial.print("] ");
    char msg[length+1];
    for (unsigned int i = 0; i < length; i++) {
        Serial.print((char)payload[i]);
        msg[i] = (char)payload[i];
    }
    Serial.println();
 
    msg[length] = '\0';
    Serial.println(msg);
 
    if(strcmp(msg,"1")==0 || strcmp(msg,"on")==0 || strcmp(msg,"ON")==0){
        Serial.println("MQTT:ON");
        switch_ON_intern();
        delay(100);
        sendInfoStatus("CMD","ON:" + String(msg));
     }
    else if(strcmp(msg,"0")==0 || strcmp(msg,"off")==0 || strcmp(msg,"OFF")==0){
        Serial.println("MQTT:OFF");
        switch_OFF_intern();
        delay(100);
        sendInfoStatus("CMD","OFF:" + String(msg));
    } else if(strcmp(msg,"?")==0) {
        sendInfos();
        delay(100);
        sendInfoStatus("CMD","Help:" + String(msg));
        reportMQTT((relStatus=="ON")?1:0);
    } else {
         sendInfoStatus("CMD","Unknown:" + String(msg));
     }
  }
}

void sendInfos() {
    sendInfoStatus("Hardware/RSSI",String(WiFi.RSSI()));
    sendInfoStatus("Hardware/IP",WiFi.localIP().toString());
    sendInfoStatus("Hardware/MAC",WiFi.macAddress());
    sendInfoStatus("Hardware/SSID",WiFi.SSID());
    sendInfoStatus("Hardware/SUBNET",WiFi.subnetMask().toString());
    sendInfoStatus("Hardware/MAC",WiFi.macAddress());
    sendInfoStatus("Hardware/NTP-Server",NTP.getNtpServerName());
    sendInfoStatus("Hardware/CPU-FREQ",String(system_get_cpu_freq()));

    sendInfoStatus("Hardware/FlashChipSize",String(ESP.getFlashChipSize()));
    sendInfoStatus("Hardware/SPIFFS-Total",String(fs_info.totalBytes));
    sendInfoStatus("Hardware/SPIFFS-Used",String(fs_info.usedBytes));
    sendInfoStatus("Hardware/StartTime",gerDate(NTP.getTimeDateString(NTP.getFirstSync())));

}

void reportMQTT(const int value) {
    if (value==1) {
       sendInfoStatus("relay_t", "on");
       sendInfoStatus("relay_i", "1");
       sendStatus("setRelay","1");
    } else {
       sendInfoStatus("relay_t", "off");
       sendInfoStatus("relay_i", "0");
       sendStatus("setRelay","0");
    }
}


void sendStatus_int(const String path,const String value) {
    String fullpath=String(path_MQTT)+"/"+path;
    char cpath[fullpath.length()+1];
    char cvalue[value.length()+1];
    fullpath.toCharArray(cpath,fullpath.length()+1);
    value.toCharArray(cvalue,value.length()+1);
    pubClient.publish(cpath, cvalue);
}

void sendStatus(const String path,const String value) {
    if (MQTT_active==1) {
        sendStatus_int(path,value);
    }
}

void sendInfoStatus(const String path,const String value) {
    String fullpath=String("info/")+path;
    sendStatus(fullpath,value);
}


void startMQTTServer() {
  if (MQTT_active==1) {
    pubClient.setServer(host_MQTT, 1883);
    pubClient.setCallback(callbackMQTT);
    build_wwwStatus2(F("MQTT server started"));
  } else {
    if (pubClient.connected()) {  
      sendStatus_int("info/starttime","-");
      sendStatus_int("info/stoptime",gerDate(NTP.getTimeDateString()));  
      pubClient.disconnect();  
      build_wwwStatus2(F("MQTT server stopped"));
    }
  }
}

 /* 746 - 747  : MQTT active /43
  * 750 - 766  : MQTT IP /44
  * 770 - 850  : MQTT PATH /45
 */
void handle_mqtt(){
   String mqtt_IP = server.arg("ip");
   String mqtt_PATH = server.arg("path");
   String mqtt_active = server.arg("active");
   
   if (mqtt_active !="") {
     eeprom_Function = 43;
     MQTT_active=mqtt_active.toInt();
     if (MQTT_active < 0 || MQTT_active>1) {MQTT_active = 0;} 
     server.send(200, F("text/html; charset=utf-8"),wwwCommandHeader +  "MQTT Active : " + String(MQTT_active) + wwwGoBack);
     delay(100);
     //Serial.println("MQTT Active");       
     writeEEPROM();       
     delay(10);
     startMQTTServer();
   }
   if (mqtt_IP !="") {
     eeprom_Function = 44;
     mqtt_IP.toCharArray(host_MQTT, 16);
     server.send(200, F("text/html; charset=utf-8"),wwwCommandHeader +  "MQTT Broker adress : " + String(host_MQTT) + wwwGoBack);
     delay(100);
     //Serial.println("MQTT Address");       
     writeEEPROM();       
   }
   else if (mqtt_PATH != "") {        
     eeprom_Function = 45;
     mqtt_PATH.toCharArray(path_MQTT, 80);
     server.send(200, F("text/html; charset=utf-8"),wwwCommandHeader +  "MQTT PATH : " + String(path_MQTT) + wwwGoBack);
     delay(100);
     //Serial.println("MQTT Path");       
     writeEEPROM();  
   }
   else {
     server.send(200, F("text/html; charset=utf-8"),wwwCommandHeader +  "MQTT nothing done" + wwwGoBack);
     delay(100);
     //Serial.println("MQTT nothing to do");  
   }
}